{% extends "teams/base.html" %}
{% load tz %}
{% load static %}
{% load render_bundle from webpack_loader %}

{% block style %}
{{ block.super }}
{% render_bundle 'hunts_puzzle' 'css' %}
{% endblock %}

{% block title %}
{{ title }} - {{ block.super }}
{% endblock %}

{% block webpack_script %}
{{ seed_data | json_script:"seed-data" }}
{% render_bundle 'hunts_puzzle' 'js' attrs='defer' %}
{% endblock %}

{% block page_header %}
	<h1 class="h2"><a href="{% url 'episode_index' episode_number %}">{{ episode_name }}</a></h1>
	<h2 id="puzzle-title" class="h1">{{ title }}</h2>
{% endblock %}

{% block content %}
{% if clues_in_flavour %}
<!-- PUZZLE STARTS HERE -->
{% if flavour %}
<section id="puzzle-flavour">
		<span id="flavour-intro">Story: </span>
		{{ flavour | safe }}
</section>
{% endif %}
<section id="puzzle-content"{% if grow_section %} class="puzzle-grow"{% endif %}>
		{{ text | safe }}
</section>
<!-- PUZZLE ENDS HERE -->
{% else %}
{% if flavour %}
<section id="puzzle-flavour">
	<!-- This is just flavour text - not related to the puzzle! -->
	<span id="flavour-intro">Story: </span>
	{{ flavour | safe }}
</section>
{% endif %}
<section id="puzzle-content"{% if grow_section %} class="puzzle-grow"{% endif %}>
<!-- PUZZLE STARTS HERE -->
{{ text | safe }}
<!-- PUZZLE ENDS HERE -->
</section>
{% endif %}

<section id="puzzle-clues">
	<button
		type="button"
		class="btn-outline-light"
		data-bs-animation="false"
		data-bs-container="#notification-popover-container"
		data-bs-html="true"
		data-bs-toggle="popover"
		data-bs-placement="bottom"
		title="Notification Settings"
		data-content-id="notification-popover-content"
		id="notification-button"
		aria-pressed="false"
		aria-label="Notification Settings"
	>🔕</button>
	<div id="notification-popover-container">
		<div class="d-none" id="notification-popover-content" aria-labelledby="notification-button">
			<p>Notify on significant puzzle events with:</p>
			<label><input type="checkbox" id="browser-notifications-cb"/> Browser Notifications</label><br>
			<span id="notification-permission-msg" class="small">Permission must be granted in the browser!</span><br>
			<label><input type="checkbox" id="sound-notifications-cb"/> Sound</label><br>
			<span id="sound-permission-msg" class="small">You may need to enable autoplay audio to reliably hear sound notifications</span>
		</div>
	</div>
	<div id="clue-list" />
</section>

<section id="puzzle-answer">
{% if answered %}
<h2>Your correct answer</h2>
<p>
	"{{ answered.guess }}" &mdash; entered by {{ answered.by.username }} at
	<span class="localtime"
		  data-utc="{{ answered.given|utc|date:"c" }}"
		  data-format="DATETIME_SHORT_WITH_SECONDS">
		{{ answered.given|date:"Y-m-d H:i:s O" }}
	</span>
	{% if answered.late %}(after the end of the event){% endif %}
</p>
{% endif %}
{% if admin or not answered and authenticated %}
<form id="answer-form" class="form-inline" action="an" method="POST">
	{% csrf_token %}
	<span id="answer-border">
		<input name="answer" id="answer-entry" class="form-control" placeholder="Enter guess" maxlength="512" />
	</span>
	<button type="submit" id="answer-button" class="btn-primary" disabled="disabled">Guess!</button>
</form>
<div id="connection-status"></div>
{% endif %}
{% if ended and not answered %}
<h3>Event is over</h3>
<p>
	You may still submit answers and solve puzzles
	{% if not authenticated %}
	by <a href="{{ login_url }}">creating an account or logging in</a>
	{% endif %}
	but your progress will not appear on leaderboards or in statistics.
</p>
{% endif %}
{% if authenticated %}
<h3>Guesses <button id="guesses-button" data-bs-toggle="collapse" data-bs-target="#guesses-container" aria-expanded="false" aria-controls="guesses-container">Show</button></h3>
<div id="guesses-container" class="collapse">
	<table id="guesses">
		<thead>
		<tr>
			<th scope="col">User</th>
			<th scope="col">Guess</th>
		</tr>
		</thead>
		<tbody id="guess-viewer-body"></tbody>
	</table>
</div>
{% endif %}
</section>
{% if ended or admin %}
<section>
<button
		id="solution-button"
		class="btn-primary"
		data-bs-toggle="collapse"
		data-bs-target="#solution-content"
		data-url="{% url 'solution_content' episode_number=episode_number puzzle_number=puzzle_number %}"
		aria-expanded="false"
		aria-controls="solution-content"
>Show Solution</button>
<div id="solution-content" class="card card-body collapse">
</div>
</section>
{% endif %}
{% endblock %}
